#include <stdint.h>

#define KEY_ESC_PRESSED			is_any_key_pressed()?is_rc_pressed(6,7):0
#define MAKE_COLOR(r,g,b)	(((uint16_t)(b>>3))<<10)|(((uint16_t)(g>>3))<<5)|(r>>3)

#define GCNF_ADDR 	0xC0000018
#define MISC_ADDR 	0x900A0008
#define FOR_DELAY	0xAAAAA
#define SCREEN_WIDTH	320
#define SCREEN_HEIGHT	240
#define SCREEN_SIZE		SCREEN_WIDTH*SCREEN_HEIGHT
#define PALETTE_SIZE	0x100
#define STEP_COLOR		3

void (*memset)(void* dest, int val, int size) = (void*) 0x10170; // Boot1 3.0.0.99
void (*memcpy)(const void* dest, const void* src, int size) = (void*) 0xFFB0;
int (*is_any_key_pressed)()= (void*)0x19974;
int (*is_rc_pressed)(int row, int col) = (void*) 0x197D0;


int main(void) {
    uint8_t* ptr=*((void **)0xC0000010);
    uint8_t color=0,color_r=0,color_g=0,color_b=0;
    uint32_t i;
	uint16_t palette[PALETTE_SIZE];
	for(i=0;i<PALETTE_SIZE;i++)
	{	palette[i]=MAKE_COLOR(color_r,color_g,color_b);
		if(color_b<255-STEP_COLOR)color_b+=STEP_COLOR;
		else if(color_r<255-STEP_COLOR) color_r+=STEP_COLOR;
		else if(color_g<255-STEP_COLOR) color_g+=STEP_COLOR;
	}
	memcpy((const void*)0xC0000200,palette,PALETTE_SIZE*2);
    // Change LCD controller settings:
	uint32_t gmode = *(volatile uint32_t*)GCNF_ADDR;
	gmode &= ~0b100001110;
	gmode |= 0b000000110;
	*(volatile uint32_t*)GCNF_ADDR= gmode;
    while (1) {
        for (; color < PALETTE_SIZE-1; color++) {
            memset(ptr, color, SCREEN_SIZE);
            for (i = 0; i < FOR_DELAY; i++);
            if (KEY_ESC_PRESSED)
                *((volatile uint32_t *)MISC_ADDR) = 2;
        }        
        for (; color > 0; color--) {
            memset(ptr, color, SCREEN_SIZE);
            for (i = 0; i < FOR_DELAY; i++);
            if (KEY_ESC_PRESSED)
                *((volatile uint32_t *)MISC_ADDR) = 2;
        }
    }
}
